def dist(p1,p2):
    return (p1[0]-p2[0])**2+\
        (p1[1]-p2[1])**2

def ppp(N):
    """
    N est une liste de tuples (x,y)
    renvoie les 2 points les + proches
    """
    p1,p2 =0,1
    d = dist(N[p1],N[p2])#min provisoire
    for i in range(len(N)):
       for j in range(i+1,len(N)):
           if dist(N[i],N[j])<d:
               p1,p2,d=i,j,dist(N[i],N[j])
    return N[p1],N[p2]


def sort_abs(a):
    a=a[:]
    a.sort(key=lambda c :c[0])
    #key est superflu
    return a

def sort_ord(a):
    a=a[:]
    a.sort(key=lambda c:c[1])
    return a

def make_pos(a):
    d={a[i]:i for i in range(len(a))}
    return d



def make_new_ay(ay,d,lo,med,hi):
    assert(lo<=med<hi)
    n = len(ay)
    left,right=[],[]
    for i in range(len(ay)):
        if lo<=d[ay[i]]<med:
            left.append(ay[i])
        elif med<=d[ay[i]]<hi:
            right.append(ay[i])
    return left,right


def closest_pair_small(a):
    assert(len(a)<=3)
    best = 0,1
    for i in range(len(a)):
        for j in range(i+1,len(a)):
            if dist(a[i],a[j]) < 
               dist(a[best[0]],a[best[1]]):
                best = i,j
    return a[best[0]],a[best[1]]

def closest_pair_small(a):
    assert(len(a)<=3)
    return ppp(a)


def make_strip(a,xmin,xmax):
    """
    a est supposé trié par ordre croissant d'ordonnées
    """
    return [p for p in a if\
            xmin<=p[0]<=xmax]


def closest_pair_in_strip(a):
    """c'est une bête recherche de min
    """
    n = len(a)
    d = dist(a[0],a[1])
    p,q=0,1
    for i in range(0,n):#n passages
        for j in range(i+1,min(i+8,n)):#<8 passage
            d2 = dist(a[i],a[j])
            if d2 < d:
                p,q=i,j
                d=d2
    return a[p],a[q]


def closest_pair(a):
    n = len(a)
    ax =  sort_abs(a)#O(n log(n))
    ay = sort_ord(a) #O(n log(n))
    dico = make_pos(ax)#O(n)
    def closest_rec(lo,hi,ay):
        # étude sur les positions [lo,hi[
        # ay est de taille hi - lo
        if len(ay)<=3:#O(1)
            return closest_pair_small(ay)
        mid = lo + (hi-lo)//2 #indice médian O(1)
        ayg,ayd=make_new_ay(ay,dico,lo,mid,hi)
        #O(n) 
        cg = closest_rec(lo,mid,ayg)# ?
        cd = closest_rec(mid,hi,ayd)# ?
        bt = cg if dist(cg[0],cg[1])<\
            dist(cd[0],cd[1]) else cd#O(1)
        d = dist(bt[0],bt[1])#O(1)
        xmed = ax[mid-1][0]#O(1)
        xmin,xmax=xmed-d,xmed+d
        strip = make_strip(ay,xmin,xmax)#O(n)
        if len(strip)<=1:
            return bt
        bs = closest_pair_in_strip(strip)#O(n)
        return bs if dist(bs[0],bs[1])<d else bt
    return closest_rec(0,n,ay)
